#!/bin/sh
MOUNTDIR=$(grep ^MOUNTDIR=.* /etc/init.d/init_ide | cut -d '=' -f 2)
SLEEPTIME=$(grep ^SLEEPTIME=.* /etc/init.d/init_ide | cut -d '=' -f 2)
HDDCACHE=$(grep ^HDDCACHE=.* /etc/init.d/init_ide | cut -d '=' -f 2)

IM=/sbin/insmod

if [ -e /var/etc/.ide_ext3 ] ; then
	fs=ext3
elif [ -e /var/etc/.ide_xfs ] ; then
	fs=xfs
else
	fs=ext2
fi

out="/dev/null"
if grep -q 'ttyS0' /var/tuxbox/boot/boot.conf; then
	out="/dev/console"
fi

if [ -e /var/etc/.start_ide ]; then
msg()
{
pidof msgbox > /dev/null && killall msgbox
/bin/msgbox cyclic=0 title="HDD Setup" size=28 msg="$text" select="Bitte warten" &
}

FORMAT()
{
text="~cStarte HDD Initialisierung~n~s~n~l~G X erstelle partitionen~n~l O initialisiere Swap Partition~n~l O formatiere Datenpartition~n~l O mounte Datenpartition nach $MOUNTDIR~n~l O configuriere HDD Parameter~n~s~n~c...der Vorgang dauert ein paar Minuten~n~s"
msg

HDD=/dev/ide/host0/bus0/target0/lun0
test_hdd ()
{
fdisk $HDD/disc << EOF
p
EOF

}

if mount | grep 'ide/host0/bus0/target0/lun0' > /dev/null; then
	/etc/init.d/endprog ide
	/etc/init.d/init_end ideein mmcaus noload $fs
fi
if mount | grep 'ide/host0/bus0/target0/lun0' > /dev/null; then
	[ -e /tmp/.part ] && rm /tmp/.part
	killall msgbox
	msg=/tmp/inst.txt
	echo ~c~FVorgang wurde abgebrochen ! > $msg
	echo ~c~YHDD ~Skonnte nicht unmountet werden. >> $msg
	echo ~s >> $msg
	echo ~cBitte alle auf HDD laufende Prozesse beenden. >> $msg
	echo ~s >> $msg
	echo ~cDanach HDD Setup erneut versuchen. >> $msg
	/bin/msgbox title="HDD Setup" refresh=1 cyclic=0 order=1 absolute=1 default=1 size=32 msg="$msg" select="HDD Setup verlassen,Alle Prozesse auf HDD beenden" timeout=300
	case "$?" in
		1)
			rm $msg
			exit
		;;
		2)
			touch /tmp/.install_ide
			touch /tmp/.msg2
			killall shellexec
			killall msgbox
			wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
			touch /tmp/.ide_fuser
			exit
		;;
		*)
			rm $msg
			exit
		;;
		esac
fi

if [ -e /tmp/.swap -a -e /var/etc/.swap -a ! -e /var/etc/.swap_tmp ] ; then
	swapoff $HDD/part1
fi
sleep 3
if [ -e /tmp/.part ] ; then
rm /tmp/.part
#Create the partition label
fdisk $HDD/disc << EOF
o
n
p
1
1
+100M
n
p
2



t
1
82
p
w
q
EOF

if [ $? -ne 0 ] ; then
	msgbox cyclic=0 title="HDD Setup" refresh=2 size=28 msg="Partitionieren und Formatieren fehlgeschlagen~nFestplatte richtig angeschlossen?" timeout=10
	exit 1
fi

text="~cStarte HDD Initialisierung~n~s~n~l X erstelle partitionen~n~l~G X initialisiere Swap Partition~n~l O formatiere Datenpartition~n~l O mounte Datenpartition nach $MOUNTDIR~n~l O configuriere HDD Parameter~n~s~n~c...der Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
mkswap $HDD/part1
killall -q msgbox
xsleep 500000
fi

text="~cStarte HDD Initialisierung~n~s~n~l X erstelle partitionen~n~l X initialisiere Swap Partition~n~l~G X formatiere Datenpartition~n~l O mounte Datenpartition nach $MOUNTDIR~n~l O configuriere HDD Parameter~n~s~n~c...der Vorgang dauert ein paar Minuten~n~s"
msg

PART="part1"
if test_hdd | grep '82  Linux swap' > /dev/null; then
	PART="part2"
fi

if [ -e /var/etc/.ide_ext3 ] ; then
	if lsmod | grep ext2 > /dev/null && [ ! -e /var/etc/.mmc_ext2 -o ! -e /var/etc/.mmc_on ] ; then rmmod ext2; fi
	if lsmod | grep xfs > /dev/null && [ ! -e /var/etc/.mmc_xfs ] ; then rmmod xfs; fi
	if ! lsmod | grep jbd > /dev/null ; then $IM jbd; fi
	if ! lsmod | grep ext3 > /dev/null ; then $IM ext3; fi
	/sbin/mkfs.ext3 -T largefile -m0 $HDD/$PART
else 
	if [ -e /var/etc/.ide_xfs ] ; then
		if lsmod | grep ext3 > /dev/null && [ ! -e /var/etc/.mmc_ext3 -o ! -e /var/etc/.mmc_on ] ; then rmmod ext3; rmmod jbd; fi
		if lsmod | grep ext2 > /dev/null && [ ! -e /var/etc/.mmc_ext2 -o ! -e /var/etc/.mmc_on ] ; then rmmod ext2; fi
		if ! lsmod | grep xfs > /dev/null ; then $IM xfs; fi
		/sbin/mkfs.xfs -l version=2 -f $HDD/$PART
	else	
		if lsmod | grep ext3 > /dev/null && [ ! -e /var/etc/.mmc_ext3 -o ! -e /var/etc/.mmc_on ] ; then rmmod ext3; rmmod jbd; fi
		if lsmod | grep xfs > /dev/null && [ ! -e /var/etc/.mmc_xfs ] ; then rmmod xfs; fi
		if ! lsmod | grep ext2 > /dev/null ; then $IM ext2; fi
		/sbin/mkfs.ext2 -T largefile -m0 $HDD/$PART
	fi
fi
text="~cStarte HDD Initialisierung~n~s~n~l X erstelle partitionen~n~l X initialisiere Swap Partition~n~l X formatiere Datenpartition~n~l~G X mounte Datenpartition nach $MOUNTDIR~n~l O configuriere HDD Parameter~n~s~n~c...der Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
if [ -e /var/etc/.ide_ext3 ] ; then
	/bin/mount -t ext3 $HDD/$PART $MOUNTDIR
else
	if [ -e /var/etc/.ide_xfs ] ; then
		/bin/mount -t xfs $HDD/$PART $MOUNTDIR
	else	
		/bin/mount -t ext2 $HDD/$PART $MOUNTDIR
	fi
fi

/sbin/hdparm -W $HDDCACHE $HDD/disc

if [ -e /tmp/.swap -a -e /var/etc/.swap -a ! -e /var/etc/.swap_tmp ] ; then
	/sbin/swapon $HDD/part1 && /bin/mount -n -t tmpfs tmpfs /tmp -o size=64M,remount
fi

text="~cStarte HDD Initialisierung~n~s~n~l X erstelle partitionen~n~l X initialisiere Swap Partition~n~l X formatiere Datenpartition~n~l X mounte Datenpartition nach $MOUNTDIR~n~l~G X configuriere HDD Parameter~n~s~n~c...der Vorgang dauert ein paar Minuten~n~s"
msg
if [ -e /var/etc/.sleep_no ] ; then
	/sbin/hdparm -S0 -M128 $HDD/disc
else
	/sbin/hdparm -S $SLEEPTIME -M128 $HDD/disc
fi
sleep 7
if mount | grep 'ide/host0/bus0/target0/lun0' > /dev/null; then
	mkdir -p $MOUNTDIR/recording
	mkdir -p $MOUNTDIR/image
	if [ -e /var/etc/.swap ] ; then
		if [ -e /var/etc/.ideconf ] ; then
			INFO="~cHDD Setup abgeschlossen~n~s~n~Y~cSWAP ist aktiviert und kann bei Bedarf im~n~c~YGLJ/IDE-Men~u ausgeschaltet werden."
		else
			INFO="~cHDD Setup abgeschlossen.~n~s~n~c~YBitte im GLJ/IDE-Men~u:~n~cGLJ-Neutrino Standard Config mit IDE/HDD ausw~ahlen.~n~c~YDanach ist die Festplatte betriebsbereit.~n~s~n~cSWAP ist aktiviert und kann im GLJ/IDE-Men~u~n~causgeschaltet werden.~n~s"
		fi
	else
		if [ -e /var/etc/.ideconf ] ; then
			INFO="~cHDD Setup abgeschlossen~n~s~n~c~YSWAP kann bei Bedarf im GLJ/IDE-Men~u eingeschaltet werden."
		else
			INFO="~cHDD Setup abgeschlossen.~n~s~n~c~YBitte im GLJ/IDE-Men~u:~n~cGLJ-Neutrino Standard Config mit IDE/HDD ausw~ahlen.~n~c~YDanach ist die Festplatte betriebsbereit.~n~s~n~cSWAP kann bei Bedarf im GLJ/IDE-Men~u eingeschaltet werden.~n~s"
		fi
	fi
	/bin/msgbox cyclic=0 title="HDD Setup" refresh=0 size=28 msg="$INFO" timeout=45
	killall -q msgbox
else
	msgbox cyclic=0 title="HDD Setup" refresh=2 size=36 msg="Vorgang abgebrochen !~nLaufwerk HDD ist nicht gemountet.~nBitte ~uberpr~ufen." timeout=30
	killall -q msgbox
	exit
fi
}
if [ -e /lib/modules/$(uname -r)/kernel/fs/xfs/xfs.o ] ; then
	text="~cUm die Festplatte in der DBox2 zu initialisieren, mu die HDD einmalig~n~cpartitioniert und formatiert werden. Dies dauert ein paar Minuten.~n~c~YBeim Partitionieren wird eine 100MB gro~ze SWAP-Partition angelegt.~n~s~n~c~YNachtr~aglich kann die Platte auf ~Sext2~Y, ~Sext3 ~Yoder ~Sxfs ~Yumformatiert werden.~n~cAlle Daten auf der Festplatte werden beim ~YSetup ~Sgel~oscht !!~n~s~n~c Setup wirklich starten ?"
	/bin/msgbox cyclic=0 title="HDD Setup" refresh=3 order=2 default=3 size=28 msg="$text" select="Partitionieren u. Format xfs,Format xfs,HDD Setup beenden,HDD Setup beenden,Partitionieren u. Format ext2,Format ext2,Partitionieren u. Format ext3,Format ext3"
else
	text="~cUm die Festplatte in der DBox2 zu initialisieren, mu die HDD einmalig~n~cpartitioniert und formatiert werden. Dies dauert ein paar Minuten.~n~c~YBeim Partitionieren wird eine 100MB gro~ze SWAP-Partition angelegt.~n~s~n~c~YNachtr~aglich kann die Platte auf ~Sext2~Y, ~Sext3 ~Yoder ~Sxfs ~Yumformatiert werden.~n~c~YXFS-Treiber ~Sk~onnen auf Wunsch mit ~Yide_mmc.tar ~Snachinstalliert werden.~n~s~n~c~YAlle Daten auf der Festplatte werden beim ~SSetup ~Ygel~oscht !!~n~cSetup wirklich starten ?"
	/bin/msgbox cyclic=0 title="HDD Setup" refresh=3 order=2 default=3 size=28 msg="$text" select="XFS not installed,XFS not installed,HDD Setup beenden,HDD Setup beenden,Partitionieren u. Format ext2,Format ext2,Partitionieren u. Format ext3,Format ext3"
fi
case "$?" in
	1)
		[ ! -e /var/etc/.ide_xfs ] && touch /var/etc/.ide_xfs
		[ -e /var/etc/.ide_ext3 ] && rm /var/etc/.ide_ext3
		[ ! -e /var/etc/.noide_ext2 ] && touch /var/etc/.noide_ext2
		touch /tmp/.part
		FORMAT
		;;
	2)
		[ ! -e /var/etc/.ide_xfs ] && touch /var/etc/.ide_xfs
		[ -e /var/etc/.ide_ext3 ] && rm /var/etc/.ide_ext3
		[ ! -e /var/etc/.noide_ext2 ] && touch /var/etc/.noide_ext2
		FORMAT
		;;
	3)
		msgbox cyclic=0 title="HDD Setup" refresh=2 size=28 msg="HDD Setup wurde beendet" timeout=3
		;;
	4)
		msgbox cyclic=0 title="HDD Setup" refresh=2 size=28 msg="HDD Setup wurde beendet" timeout=3
		;;
	5)
		[ -e /var/etc/.ide_ext3 ] && rm /var/etc/.ide_ext3
		[ -e /var/etc/.ide_xfs ] && rm /var/etc/.ide_xfs
		[ -e /var/etc/.noide_ext2 ] && rm /var/etc/.noide_ext2
		touch /tmp/.part
		FORMAT
		;;
	6)
		[ -e /var/etc/.ide_ext3 ] && rm /var/etc/.ide_ext3
		[ -e /var/etc/.ide_xfs ] && rm /var/etc/.ide_xfs
		[ -e /var/etc/.noide_ext2 ] && rm /var/etc/.noide_ext2
		FORMAT
		;;
	7)
		[ ! -e /var/etc/.ide_ext3 ] && touch /var/etc/.ide_ext3
		[ -e /var/etc/.ide_xfs ] && rm /var/etc/.ide_xfs
		[ ! -e /var/etc/.noide_ext2 ] && touch /var/etc/.noide_ext2
		touch /tmp/.part
		FORMAT
		;;
	8)
		[ ! -e /var/etc/.ide_ext3 ] && touch /var/etc/.ide_ext3
		[ -e /var/etc/.ide_xfs ] && rm /var/etc/.ide_xfs
		[ ! -e /var/etc/.noide_ext2 ] && touch /var/etc/.noide_ext2
		FORMAT
		;;
	*)
		#msgbox cyclic=0 title="HDD Setup" refresh=2 size=28 msg="HDD Setup wurde beendet" timeout=3
		exit
		;;
		esac
else
/bin/msgbox cyclic=0 msg="HDD/IDE Treiber nicht geladen, Abbruch" timeout=5
killall -q msgbox
fi
